import { RequestPayment } from './RequestPayment';
import APIRequest from './api';
import { AxiosResponse } from 'axios';
import { ITransactionResponse } from './types';
export declare class Mazzuma {
    readonly apiKey: string;
    readonly request?: APIRequest;
    readonly MTN_TO_MTN: string;
    readonly MTN_TO_AIRTEL: string;
    readonly MTN_TO_VODAFONE: string;
    readonly MTN_TO_TIGO: string;
    readonly AIRTEL_TO_MTN: string;
    readonly AIRTEL_TO_AIRTEL: string;
    readonly AIRTEL_TO_VODAFONE: string;
    readonly AIRTEL_TO_TIGO: string;
    readonly TIGO_TO_MTN: string;
    readonly TIGO_TO_AIRTEL: string;
    readonly TIGO_TO_VODAFONE: string;
    readonly TIGO_TO_TIGO: string;
    readonly VODAFONE_TO_MTN: string;
    readonly VODAFONE_TO_AIRTEL: string;
    readonly VODAFONE_TO_VODAFONE: string;
    readonly VODAFONE_TO_TIGO: string;
    constructor(apiKey: string, request?: APIRequest);
    create(cashflowDirection: string): RequestPayment;
    transactionStatus(transactionId: string): Promise<AxiosResponse<ITransactionResponse>>;
    protected networkLookup(flowDirection: string): "mtn" | "airtel" | "tigo" | "vodafone";
    protected newRequestPayment(apiKey: string, flowDirection: string, network: string, api?: any): RequestPayment;
}
