import axios from 'axios';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */



var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};









function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var RequestPayment = /** @class */ (function () {
    function RequestPayment(apiKey, option, network, request) {
        this.option = option;
        this.apiKey = apiKey;
        this.network = network;
        this.apiRequest = request;
    }
    RequestPayment.prototype.create = function (payload) {
        var fullPayload = this.mapPayload(payload);
        return this.makeRequest(fullPayload);
    };
    RequestPayment.prototype.mapPayload = function (payload) {
        var amount = payload.amount, to = payload.to, from = payload.from;
        return {
            price: amount,
            network: this.network,
            recipient_number: to,
            sender: from,
            option: this.option,
            apikey: this.apiKey
        };
    };
    RequestPayment.prototype.makeRequest = function (payload) {
        return this.apiRequest.paymentRequest(payload);
    };
    return RequestPayment;
}());

var Mazzuma = /** @class */ (function () {
    // create constructor that requires api key
    function Mazzuma(apiKey, request) {
        this.MTN_TO_MTN = 'rmtm';
        this.MTN_TO_AIRTEL = 'rmta';
        this.MTN_TO_VODAFONE = 'rmtv';
        this.MTN_TO_TIGO = 'rmtt';
        this.AIRTEL_TO_MTN = 'ratm';
        this.AIRTEL_TO_AIRTEL = 'rata';
        this.AIRTEL_TO_VODAFONE = 'ratv';
        this.AIRTEL_TO_TIGO = 'ratt';
        this.TIGO_TO_MTN = 'rttm';
        this.TIGO_TO_AIRTEL = 'rtta';
        this.TIGO_TO_VODAFONE = 'rttv';
        this.TIGO_TO_TIGO = 'rttt';
        this.VODAFONE_TO_MTN = 'rvtm';
        this.VODAFONE_TO_AIRTEL = 'rvta';
        this.VODAFONE_TO_VODAFONE = 'rvtv';
        this.VODAFONE_TO_TIGO = 'rvtt';
        this.apiKey = apiKey;
        this.request = request;
    }
    // request a payment
    Mazzuma.prototype.create = function (cashflowDirection) {
        var network = this.networkLookup(cashflowDirection);
        return this.newRequestPayment(this.apiKey, cashflowDirection, network, this.request);
    };
    // check transaction status
    Mazzuma.prototype.transactionStatus = function (transactionId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request.transactionStatus(transactionId)];
            });
        });
    };
    Mazzuma.prototype.networkLookup = function (flowDirection) {
        switch (flowDirection) {
            case this.MTN_TO_MTN:
            case this.MTN_TO_AIRTEL:
            case this.MTN_TO_VODAFONE:
            case this.MTN_TO_TIGO:
                return 'mtn';
                break;
            case this.AIRTEL_TO_MTN:
            case this.AIRTEL_TO_AIRTEL:
            case this.AIRTEL_TO_VODAFONE:
            case this.AIRTEL_TO_TIGO:
                return 'airtel';
                break;
            case this.TIGO_TO_MTN:
            case this.TIGO_TO_AIRTEL:
            case this.TIGO_TO_VODAFONE:
            case this.TIGO_TO_TIGO:
                return 'tigo';
                break;
            case this.VODAFONE_TO_MTN:
            case this.VODAFONE_TO_AIRTEL:
            case this.VODAFONE_TO_VODAFONE:
            case this.VODAFONE_TO_TIGO:
                return 'vodafone';
                break;
        }
    };
    Mazzuma.prototype.newRequestPayment = function (apiKey, flowDirection, network, api) {
        return new RequestPayment(apiKey, flowDirection, network, api);
    };
    return Mazzuma;
}());

var BASE_URL = 'https://client.teamcyst.com/';
var serialize = function (obj) {
    return Object.keys(obj)
        .map(function (key) { return encodeURIComponent(key) + "=" + encodeURIComponent(obj[key]); })
        .join("&");
};
var APIRequest = /** @class */ (function () {
    function APIRequest() {
    }
    APIRequest.prototype.request = function () {
        return axios.create({
            baseURL: BASE_URL
        });
    };
    APIRequest.prototype.get = function (url, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request().get(url, __assign({}, options))];
            });
        });
    };
    APIRequest.prototype.post = function (url, data, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.request().post(url, data, __assign({}, options))];
            });
        });
    };
    APIRequest.prototype.paymentRequest = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                url = "api_call.php";
                return [2 /*return*/, this.post(url, payload)];
            });
        });
    };
    APIRequest.prototype.transactionStatus = function (transactionId) {
        return __awaiter(this, void 0, void 0, function () {
            var data, url;
            return __generator(this, function (_a) {
                data = {
                    orderID: transactionId
                };
                url = "checktransaction.php?" + serialize(data);
                return [2 /*return*/, this.get(url)];
            });
        });
    };
    return APIRequest;
}());

function mazzuma(apiKey) {
    var api = new APIRequest();
    return new Mazzuma(apiKey, api);
}

export { mazzuma };
